﻿Imports System.IO

Public Class Main

    WithEvents tb As TextBox
    Dim tab As TabPage
    Dim f As Font = New Font("MS UI Gothic", 12)

    Private Sub Form1_Load() Handles MyBase.Load
        Od.InitialDirectory = My.Settings.file
        Od.ShowDialog()
        If My.Settings.fname <> "" Then
            f = New Font(My.Settings.fname, 12)
        End If
    End Sub

    Private Sub 開く_Click() Handles 開く.Click
        Od.ShowDialog()
    End Sub

    Private Sub ShiftJIS_Click() Handles ShiftJIS.Click
        CType(Tc.SelectedTab.Controls(0), TextBox).Text =
            File.ReadAllText(Tc.SelectedTab.Tag, System.Text.Encoding.GetEncoding("SHIFT-jis"))
    End Sub

    Private Sub cUnicode_Click() Handles cUnicode.Click
        CType(Tc.SelectedTab.Controls(0), TextBox).Text =
            File.ReadAllText(Tc.SelectedTab.Tag, System.Text.Encoding.GetEncoding("Unicode"))
    End Sub

    Private Sub fclose_Click() Handles fclose.Click
        If MsgBox("変更を保存しますか？", 36) = vbYes Then
            File.WriteAllText(Tc.SelectedTab.Tag, CType(Tc.SelectedTab.Controls(0), TextBox).Text,
                              System.Text.Encoding.GetEncoding("SHIFT-jis"))
        End If
        Tc.SelectedTab.Dispose()
        If Tc.TabCount = 0 Then
            Application.Exit()
        End If
    End Sub

    Private Sub Od_FileOk() Handles Od.FileOk
        Call dcandfc()
    End Sub

    Private Sub 終了_Click() Handles 終了.Click
        Application.Exit()
    End Sub

    Private Sub Ow_Click() Handles Ow.Click
        File.WriteAllText(Tc.SelectedTab.Tag, CType(Tc.SelectedTab.Controls(0), TextBox).Text,
                          System.Text.Encoding.GetEncoding("SHIFT-jis"))
    End Sub

    Private Sub sFont_Click() Handles sFont.Click
        Fd.Font = Tc.SelectedTab.Controls(0).Font
        If Fd.ShowDialog <> DialogResult.Cancel Then
            f = Fd.Font
            My.Settings.fname = Fd.Font.Name

        Dim s(4) As String
        'フォント変更
        For i = 0 To Tc.TabCount - 1
            s(i) = Tc.SelectedTab.Tag
        Next
        Tc.TabPages.Clear()
        'バグるので呼び出し先にtryしてある
        For i = 0 To 4
            dcandfc(True, s(i))
            Next
        End If
    End Sub

    Sub dcandfc(Optional ByVal b As Boolean = False, Optional s As String = "")
        Try
            'タブ追加
            '下処理
            If Tc.TabCount <= 5 Then
                tb = New TextBox
                With tb
                    .ScrollBars = ScrollBars.Both
                    .Multiline = True
                    .Font = f
                    .Size = New Size(Tc.Width, Tc.Height)
                    .Dock = DockStyle.Fill
                End With
                '追加処理
                tab = New TabPage
                If b = False Then
                    tab.Text = IO.Path.GetFileName(Od.FileName)
                    tab.Tag = Od.FileName
                    tb.Text = File.ReadAllText(Od.FileName, System.Text.Encoding.GetEncoding("SHIFT-jis"))
                    My.Settings.file = Path.GetDirectoryName(Od.FileName)
                Else
                    tab.Text = IO.Path.GetFileName(s)
                    tab.Tag = s
                    tb.Text = File.ReadAllText(s, System.Text.Encoding.GetEncoding("SHIFT-jis"))
                End If
                '最後の処理
                Tc.TabPages.Add(tab)
                tab.Controls.Add(tb)
                Tc.SelectedIndex = Tc.TabCount + 1
                Call tb_Click()
            Else
                MsgBox("一度に編集できるファイルの数は5つまでです!", 16)
            End If
        Catch
        End Try
    End Sub

    Private Sub tb_Click() Handles tb.Click
        '行数表示
        Tc.Tag = CType(Tc.SelectedTab.Controls(0), TextBox).GetLineFromCharIndex(tb.SelectionStart) + 1
        lines.Text = Tc.Tag.ToString + "行"
        Me.Focus() 'textboxをクリックすると選択解除させるため
    End Sub

    Public Sub tb_Keydown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles tb.KeyDown
        If e.KeyData = Keys.Down Or Keys.Up Then
            Call tb_Click()
        End If
    End Sub

    Private Sub 検索_Click() Handles 検索.Click
        Dim se As New serch
        se.Show()
    End Sub

    Private Sub 行に移動_Click() Handles 行に移動.Click
        cscroll.Show()
    End Sub
End Class
